/************************************************************************************************
 
 ϸ   : CANPro.h
 ȸ   : RealSYS
 ۼ¥ : 2010. 6. 7
 ۼ   : K.S.Y
      : CANPro   ̺귯
 

 [ Revision History ]
 2012. 6. 28 - Callback ߰

************************************************************************************************/

#ifndef _CANPRO_H_
#define _CANPRO_H_

#include<windows.h>
#include<stdio.h>
#include<mmsystem.h>
#include "ftd2xx.h"
	
#define DEVICE_DESCRIPTION		"CANPro Analyzer"
#define FRAME_SIZE				12800

#define START_CHAR				':'
#define ERROR_CHAR				'?'
#define END_CHAR				0x0d


typedef enum
{
	CAN20A	= 0,
	CAN20B	= 1
}ENUM_CAN_MODE;

typedef enum
{
	CAN_DATA_FRAME		= 0,
	CAN_REMOTE_FRAME	= 1
}ENUM_CAN_DATA_TYPE;

typedef enum
{
	RECEIVE_OK	= 0,
	CAN_ERROR	= 1,
	USB_ERROR	= 2	
}ENUM_RECV;

typedef enum
{
	TX_WARNING			= 0,
	RX_WARNING			= 1,
	TX_ERROR_PASSIVE	= 2,
	RX_ERROR_PASSIVE	= 3,
	BUSOFF_ERROR		= 4
}ENUM_ERROR;

typedef enum
{
	READ_RECV_ENV	= 0,
	STOP_RECV_ENV	= 1,
	START_RECV_ENV	= 2
}ENUM_RECV_ENV;

typedef struct
{
	BOOL	MessageMode;		// 0 : CAN2.0A, 1 : CAN2.0B
	BOOL	BusOFFtoReset;		// 1 : CAN Bus-Off߻  ڵ CAN Reset 
	BOOL	BusOFFtoError;		// 1 : CAN Bus-Off߻    ˸
	BOOL	PassiveError;		// 1 : CAN , Erorr-Passive߻   ˸
	BOOL	WarningError;		// 1 : CAN , Warning߻   ˸
	WORD	BitTime;			// Bit Time
	DWORD	ID;					//  ID
	DWORD	Mask;				//  Mask
}STRUCT_CAN_ENV;

typedef struct
{
	BOOL	MessageMode;		// 0 : CAN2.0A, 1 : CAN2.0B
	BOOL	MessageType;		// 0 : Data Frame, 1 : Remote Frame
	int		DataSize;			//   : 0 ~ 8
	DWORD	ID;					// ID
	BYTE	Data[8];			// Data
}STRUCT_CAN_DATA;



// CANPro Library Class
class __declspec(dllexport) CCANPro
{
public:
	CCANPro();

	BOOL	InitPort(char *DeviceSerial);					// ڷ  ø ѹ 
	void	ClosePort();									//  
	void	SetMessage(HWND *pParent, UINT nMessage);		// ͹  ޽ , pParent NULL̸ ޽  
	void	SetBuffer(STRUCT_CAN_DATA *stRecvData);			// ͹ ͸ ־ ü
	void	PurgePort();									// USB  ʱȭ

	// 2013. 8. 27
	void	SetTimeout(int nMsec);							//   ð  ( 5 ~ 1000 msec )

	// 2012. 6. 28
	// Message ƴ Callback CANͼ   
	void	SetCallbackFunction( void (*pFunction)( BYTE nReceiveType, BYTE nErrorType ) );

	BOOL	GetDeviceNum(int *nNum);						//  ִ CANPro ľ
	BOOL	GetDeviceSerial(char **Buff);					//  ִ CANPro øȣ (øȣ 8byte)
							
	BOOL	SendData(char* szData);							// CANPro  
	BOOL	ReadData(char* szData, int nTimeout);			// CANPro  о, Timeoutŭ ٸ.
	BOOL	WriteEnv(STRUCT_CAN_ENV *stData);				// ȯ漳  Լ
	BOOL	ReadEnv(STRUCT_CAN_ENV *stData);				// ȯ漳 д Լ
	BOOL	WriteData(STRUCT_CAN_DATA *stData);				// ͸  Լ
	BOOL	RecvEnv(int nCommand, BOOL *bStatus);			// ż Լ(ΰ, Ž, )

	BOOL	Reset();										// CANPro Reset
	BOOL	GetVersion(int *nMajor, int *nMinor);			// CANPro Firmware   

protected:
	HMODULE		m_hModule;
	FT_HANDLE	m_hUSB;
	BOOL		m_bLoadDriver;
	char		m_szSerial[10];

	HANDLE		m_hThread;
	char		m_szThreadRxBuff[FRAME_SIZE];
	int			m_nThreadRxBuffLen;
	char		m_szThreadTxBuff[FRAME_SIZE];
	int			m_nThreadTxBuffLen;

	HANDLE		m_hShutdownEvent;
	HANDLE		m_hReadEvent;
	HANDLE		m_hWriteEvent;
	HANDLE		m_hEventArray[3];

	BOOL		m_bRecvResponse;

	STRUCT_CAN_DATA	*m_stRecvData;

	HWND*		m_pParent;
	UINT		m_Message;

	int			m_nTimeout;

	// CANPro ͼ Ǵ ߻ ȣ ݹԼ
	// bError - 0 : , 1 : 
	// nErrorType - ENUM_ERROR Ǿִ  Ѱ
	void		(*m_pCallback)( BYTE nReceiveType, BYTE nErrorType );

	void		SendApplication( BYTE nReceiveType, BYTE nErrorType );
	void		UnloadDriver();
	void		LoadDriver();

	BOOL		MakeThread();
	BOOL		DestroyThread();
	static UINT	USBThread(LPVOID pParam);

	void		RecvData();

	int			MakeCheckSum(char* szData);
};


#endif
