// TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Test.h"
#include "TestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define WM_CAN_MSG	(WM_USER + 10)

#define SUPPORTED_BPS_NUM		9
const CString g_strCANbps[SUPPORTED_BPS_NUM] = 
{
	_T("1M"), _T("500K"), _T("250K"), _T("200K"), _T("125K"), 
	_T("100K"), _T("50K"), _T("40K"), _T("25K")
};
const int g_nCANbps[SUPPORTED_BPS_NUM][3] = 
{
	// BRP, TSEG2, TSEG1
	{3, 3, 4},		// 1M
	{7, 3, 4},		// 500K
	{15, 3, 4},		// 250K
	{19, 3, 4},		// 200K
	{31, 3, 4},		// 125K
	{39, 3, 4},		// 100K
	{39, 7, 10},	// 50K
	{49, 7, 10},	// 40K
	{63, 7, 15}		// 25K
};

// CTestDlg Class Point
CTestDlg *g_pTestDlg = NULL;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDlg dialog

CTestDlg::CTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDlg)
	DDX_Control(pDX, IDC_COMBO_RECEIVE_TYPE, m_ctrlComboReceiveType);
	DDX_Control(pDX, IDC_STATIC_VERSION, m_ctrlVersion);
	DDX_Control(pDX, IDC_BUTTON_RECV_STOP, m_ctrlRecvStop);
	DDX_Control(pDX, IDC_BUTTON_RECV_START, m_ctrlRecvStart);
	DDX_Control(pDX, IDC_BUTTON_PERIOD_SEND, m_ctrlPeriodSend);
	DDX_Control(pDX, IDC_BUTTON_SEND, m_ctrlSend);
	DDX_Control(pDX, IDC_EDIT_SEND_DATA, m_ctrlSendData);
	DDX_Control(pDX, IDC_EDIT_SEND_ID, m_ctrlSendID);
	DDX_Control(pDX, IDC_COMBO_SEND_DATA_SIZE, m_ctrlSendSize);
	DDX_Control(pDX, IDC_COMBO_SEND_FRAME_TYPE, m_ctrlSendType);
	DDX_Control(pDX, IDC_COMBO_SEND_PROTOCOL, m_ctrlSendProtocol);
	DDX_Control(pDX, IDC_BUTTON_RESET, m_ctrlReset);
	DDX_Control(pDX, IDC_EDIT_RECEIVE_MASKID, m_ctrlRecvMaskID);
	DDX_Control(pDX, IDC_EDIT_RECEIVE_ID, m_ctrlRecvID);
	DDX_Control(pDX, IDC_BUTTON_ENV_WRITE, m_ctrlWriteEnv);
	DDX_Control(pDX, IDC_BUTTON_ENV_READ, m_ctrlReadEnv);
	DDX_Control(pDX, IDC_CHECK_WARNING_ERROR, m_ctrlWarningError);
	DDX_Control(pDX, IDC_CHECK_PASSIVE_ERROR, m_ctrlPassiveError);
	DDX_Control(pDX, IDC_CHECK_BUSOFF_ERROR, m_ctrlBusoffError);
	DDX_Control(pDX, IDC_CHECK_BUSOFF_RESET, m_ctrlBusoffReset);
	DDX_Control(pDX, IDC_COMBO_BPS, m_ctrlCANbps);
	DDX_Control(pDX, IDC_COMBO_PROTOCOL, m_ctrlProtocol);
	DDX_Control(pDX, IDC_BUTTON_DISCONNECT, m_ctrlDisconnect);
	DDX_Control(pDX, IDC_BUTTON_CONNECT, m_ctrlConnect);
	DDX_Control(pDX, IDC_BUTTON_RESEARCH, m_ctrlResearch);
	DDX_Control(pDX, IDC_COMBO_DEVICE, m_ctrlDevice);
	DDX_Control(pDX, IDC_LIST_RECV, m_ctrlList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_ENV_READ, OnButtonEnvRead)
	ON_BN_CLICKED(IDC_BUTTON_RESEARCH, OnButtonResearch)
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnButtonConnect)
	ON_BN_CLICKED(IDC_BUTTON_DISCONNECT, OnButtonDisconnect)
	ON_BN_CLICKED(IDC_BUTTON_ENV_WRITE, OnButtonEnvWrite)
	ON_BN_CLICKED(IDC_BUTTON_RESET, OnButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_SEND, OnButtonSend)
	ON_BN_CLICKED(IDC_BUTTON_PERIOD_SEND, OnButtonPeriodSend)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_RECV_START, OnButtonRecvStart)
	ON_BN_CLICKED(IDC_BUTTON_RECV_STOP, OnButtonRecvStop)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_CAN_MSG, OnReceive)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDlg message handlers

BOOL CTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	g_pTestDlg = this;

	InitDlgCtrl();			// ̾˷α Ʈ ʱȭ
	EnableCtrl(FALSE);		// CAN  ƴϴ Ʈѵ Ȱȭ
	OnButtonResearch();		//   CAN ˻
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CTestDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	m_ctrlPeriodSend.SetCheck(FALSE);
	OnButtonPeriodSend();			 	// 100ms   ߴ
	m_CAN.ClosePort();					// CAN  
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Ʈڽ ڿ ִ߰ Լ
void CTestDlg::AddString(LPCTSTR str)
{
	m_ctrlList.AddString(str);
	m_ctrlList.SetCurSel(m_ctrlList.GetCount()-1);
}

// ̾˷α Ʈ ʱȭ
void CTestDlg::InitDlgCtrl()
{
	int i;
	CString str;

	m_ctrlVersion.SetWindowText(_T(""));

	m_ctrlComboReceiveType.ResetContent();
	m_ctrlComboReceiveType.AddString( _T("Message ") );
	m_ctrlComboReceiveType.AddString( _T("Callback ") );
	m_ctrlComboReceiveType.SetCurSel(0);
	
	// ȯ 
	m_ctrlProtocol.ResetContent();
	m_ctrlProtocol.AddString(_T("CAN2.0A"));
	m_ctrlProtocol.AddString(_T("CAN2.0B"));
	m_ctrlProtocol.SetCurSel(0);

	m_ctrlCANbps.ResetContent();
	for(i = 0; i < SUPPORTED_BPS_NUM; i++) m_ctrlCANbps.AddString(g_strCANbps[i]);
	m_ctrlCANbps.SetCurSel(2);		// Select 250K

	m_ctrlRecvID.SetWindowText(_T(""));
	m_ctrlRecvMaskID.SetWindowText(_T(""));

	// ۽ 
	m_ctrlSendProtocol.ResetContent();
	m_ctrlSendProtocol.AddString(_T("CAN2.0A"));
	m_ctrlSendProtocol.AddString(_T("CAN2.0B"));
	m_ctrlSendProtocol.SetCurSel(0);

	m_ctrlSendType.ResetContent();
	m_ctrlSendType.AddString(_T("Data Frame"));
	m_ctrlSendType.AddString(_T("Remote Frame"));
	m_ctrlSendType.SetCurSel(0);

	m_ctrlSendSize.ResetContent();
	for(i = 0; i <= 8; i++)
	{
		str.Format(_T("%d"), i);
		m_ctrlSendSize.AddString(str);
	}
	m_ctrlSendSize.SetCurSel(8);

	m_ctrlSendID.SetWindowText(_T(""));
	m_ctrlSendData.SetWindowText(_T(""));
}

// ϶, ϶ ƮѴ Լ
void CTestDlg::EnableCtrl(BOOL bConnect)
{
	if(bConnect)
	{
		m_ctrlResearch.EnableWindow(FALSE);
		m_ctrlComboReceiveType.EnableWindow(FALSE);
		m_ctrlConnect.EnableWindow(FALSE);
		m_ctrlDisconnect.EnableWindow(TRUE);
		m_ctrlReset.EnableWindow(TRUE);

		m_ctrlProtocol.EnableWindow(TRUE);
		m_ctrlCANbps.EnableWindow(TRUE);
		m_ctrlRecvID.EnableWindow(TRUE);
		m_ctrlRecvMaskID.EnableWindow(TRUE);
		m_ctrlBusoffReset.EnableWindow(TRUE);
		m_ctrlBusoffError.EnableWindow(TRUE);
		m_ctrlPassiveError.EnableWindow(TRUE);
		m_ctrlWarningError.EnableWindow(TRUE);
		m_ctrlReadEnv.EnableWindow(TRUE);
		m_ctrlWriteEnv.EnableWindow(TRUE);

		m_ctrlSendProtocol.EnableWindow(TRUE);
		m_ctrlSendType.EnableWindow(TRUE);
		m_ctrlSendSize.EnableWindow(TRUE);
		m_ctrlSendID.EnableWindow(TRUE);
		m_ctrlSendData.EnableWindow(TRUE);
		m_ctrlSend.EnableWindow(TRUE);
		m_ctrlPeriodSend.EnableWindow(TRUE);

		m_ctrlRecvStart.EnableWindow(TRUE);
		m_ctrlRecvStop.EnableWindow(FALSE);
	}
	else
	{
		m_ctrlResearch.EnableWindow(TRUE);
		m_ctrlComboReceiveType.EnableWindow(TRUE);
		m_ctrlConnect.EnableWindow(TRUE); 
		m_ctrlDisconnect.EnableWindow(FALSE);
		m_ctrlReset.EnableWindow(FALSE);

		m_ctrlProtocol.EnableWindow(FALSE);
		m_ctrlCANbps.EnableWindow(FALSE);
		m_ctrlRecvID.EnableWindow(FALSE);
		m_ctrlRecvMaskID.EnableWindow(FALSE);
		m_ctrlBusoffReset.EnableWindow(FALSE);
		m_ctrlBusoffError.EnableWindow(FALSE);
		m_ctrlPassiveError.EnableWindow(FALSE);
		m_ctrlWarningError.EnableWindow(FALSE);
		m_ctrlReadEnv.EnableWindow(FALSE);
		m_ctrlWriteEnv.EnableWindow(FALSE);

		m_ctrlSendProtocol.EnableWindow(FALSE);
		m_ctrlSendType.EnableWindow(FALSE);
		m_ctrlSendSize.EnableWindow(FALSE);
		m_ctrlSendID.EnableWindow(FALSE);
		m_ctrlSendData.EnableWindow(FALSE);
		m_ctrlSend.EnableWindow(FALSE);
		m_ctrlPeriodSend.EnableWindow(FALSE);

		m_ctrlRecvStart.EnableWindow(FALSE);
		m_ctrlRecvStop.EnableWindow(FALSE);
	}
}

// CANPro  ˻
void CTestDlg::OnButtonResearch() 
{
	char **Serial;
	int DeviceNum, i;

	//  CAN Pro  
	m_CAN.GetDeviceNum(&DeviceNum);

	// ŭ Ҵ
	Serial = (char**) malloc (sizeof(char) * DeviceNum);
	for(i = 0; i < DeviceNum; i++)
	{
		Serial[i] = (char*) malloc(sizeof(char) * 10);
	}

	// Serial 
	m_CAN.GetDeviceSerial(Serial);

	// ޺ڽ Serial 
	m_ctrlDevice.ResetContent();
	for(i = 0; i < DeviceNum; i++)
	{
		m_ctrlDevice.AddString(Serial[i]);
	}
	m_ctrlDevice.SetCurSel(0);
}

// CANPro 
void CTestDlg::OnButtonConnect() 
{
	CString serial;
	BYTE nReceiveType = m_ctrlComboReceiveType.GetCurSel();

	// ޺ڽ  ø ȣ 
	m_ctrlDevice.GetLBText(m_ctrlDevice.GetCurSel(), serial);

	// CAN & USB ʱȭ
	if(!m_CAN.InitPort((LPSTR)(LPCTSTR)serial)) return;

	// CAN͸ Message Ź
	if( nReceiveType == 0 )
	{
		//   Ǵ ߻ ȣ ޽
		m_CAN.SetMessage(&this->m_hWnd, WM_CAN_MSG);
		//  Ƿ NULL 
		m_CAN.SetCallbackFunction(NULL);
	}
	// CAN͸ Callback Ź
	else if( nReceiveType == 1 )
	{
		//  Ƿ NULL 
		m_CAN.SetMessage(NULL, WM_CAN_MSG);
		//   Ǵ ߻ ȣ Լ
		m_CAN.SetCallbackFunction( MyCallback );
	}
	

	//     ü
	m_CAN.SetBuffer(&m_CANData);
	
	// 2013.8.27 ð 50msec 
	m_CAN.SetTimeout(50);

	EnableCtrl(TRUE);		// CAN  Ʈ Ȱȭ
	VersionCheck();			//  üũ
	OnButtonRecvStop();		//  
}

// CANPro 
void CTestDlg::OnButtonDisconnect() 
{
	m_ctrlPeriodSend.SetCheck(FALSE);		//   ư üũ Ǯ
	OnButtonPeriodSend();					//   
	OnButtonRecvStop();						//  
	m_CAN.ClosePort();						// CAN 

	EnableCtrl(FALSE);						// CAN  Ʈ Ȱȭ
	m_ctrlVersion.SetWindowText(_T(""));	//  龲
}

// CANPro ߿  
void CTestDlg::VersionCheck()
{
	int major, minor;
	CString str;

	// CAN ߿   
	if(!m_CAN.GetVersion(&major, &minor)) return;

	str.Format(_T("CANPro V %d.%d"), major, minor);
	m_ctrlVersion.SetWindowText(str);
}

// CANPro ȯ漳 б
void CTestDlg::OnButtonEnvRead() 
{
	int BRP, TSEG2, TSEG1;
	double bps;
	CString str, strTemp;

	// ȯ漳 о
	if(!m_CAN.ReadEnv(&m_CANEnv)) return;

	// ޽ 
	str.Empty();	
	if(m_CANEnv.MessageMode == CAN20A) str = _T("CAN2.0A  ");
	else str = _T("CAN2.0B  ");

	// BPS
	BRP = ((m_CANEnv.BitTime >> 8) & 0xFF);
	TSEG2 = ((m_CANEnv.BitTime >> 4) & 0xF);
	TSEG1 = (m_CANEnv.BitTime & 0xF);
	bps = (double)40000000 / (double)((BRP + 1) * ((TSEG1 + 1) + (TSEG2 + 1) + 1));
	bps /= 1000;
	strTemp.Format(_T("%.2fK BPS  "), bps);
	str += strTemp;

	// ID, MASK ID
	if(m_CANEnv.MessageMode == CAN20A)		// CAN2.0A 4Ʈ
	{
		strTemp.Format(_T(" ID:%03X  "), m_CANEnv.ID);
		str += strTemp;

		strTemp.Format(_T(" Mask ID:%03X  "), m_CANEnv.Mask);
		str += strTemp;
	}
	else									// CAN2.0B 8Ʈ
	{
		strTemp.Format(_T(" ID:%08X  "), m_CANEnv.ID);
		str += strTemp;

		strTemp.Format(_T(" Mask ID:%08X  "), m_CANEnv.Mask);
		str += strTemp;
	}

	AddString(str);
}

// CANPro ȯ漳 
void CTestDlg::OnButtonEnvWrite() 
{
	DWORD nTemp;
	CString strTemp;

	// Setting
	m_CANEnv.MessageMode = m_ctrlProtocol.GetCurSel();
	m_CANEnv.BusOFFtoReset = m_ctrlBusoffReset.GetCheck();
	m_CANEnv.BusOFFtoError = m_ctrlBusoffError.GetCheck();
	m_CANEnv.PassiveError = m_ctrlPassiveError.GetCheck();
	m_CANEnv.WarningError = m_ctrlWarningError.GetCheck();

	// BPS
	nTemp = m_ctrlCANbps.GetCurSel();
	m_CANEnv.BitTime = (g_nCANbps[nTemp][0]<<8) | (g_nCANbps[nTemp][1]<<4) | (g_nCANbps[nTemp][2]);

	// ID
	m_ctrlRecvID.GetWindowText(strTemp);
	nTemp = strtoul((LPSTR)(LPCTSTR)strTemp, NULL, 16);
	if(m_CANEnv.MessageMode == CAN20A) m_CANEnv.ID = nTemp & 0x7FF;
	else m_CANEnv.ID = nTemp & 0x1FFFFFFF;

	// MASK ID
	m_ctrlRecvMaskID.GetWindowText(strTemp);
	nTemp = strtoul((LPSTR)(LPCTSTR)strTemp, NULL, 16);
	if(m_CANEnv.MessageMode == CAN20A) m_CANEnv.Mask = nTemp & 0x7FF;
	else m_CANEnv.Mask = nTemp & 0x1FFFFFFF;
	
	if(!m_CAN.WriteEnv(&m_CANEnv)) return;

	AddString(_T("[   Ϸ ]"));
}

// CANPro 
void CTestDlg::OnButtonReset() 
{
	if(m_CAN.Reset()) AddString(_T("[  ]"));
	else AddString(_T("[   ]"));
}

//  
void CTestDlg::OnButtonSend() 
{
	STRUCT_CAN_DATA CANData;
	CString strTemp;
	DWORD nTemp;
	char szTemp[3];
	int i;

	memset(&CANData, NULL, sizeof(STRUCT_CAN_DATA));
	memset(szTemp, NULL, 3);

	// Setting
	CANData.MessageMode = m_ctrlSendProtocol.GetCurSel();
	CANData.MessageType = m_ctrlSendType.GetCurSel();
	CANData.DataSize = m_ctrlSendSize.GetCurSel();

	// ID
	m_ctrlSendID.GetWindowText(strTemp);
	nTemp = strtoul((LPSTR)(LPCTSTR)strTemp, NULL, 16);
	if(CANData.MessageMode == CAN20A) CANData.ID = nTemp & 0x7FF;
	else if(CANData.MessageMode == CAN20B) CANData.ID = nTemp & 0x1FFFFFFF;

	// Data
	m_ctrlSendData.GetWindowText(strTemp);
	if(strTemp.GetLength() < (CANData.DataSize * 2))
	{
		nTemp = (CANData.DataSize * 2) - strTemp.GetLength();
		for(i = 0; i < (int)nTemp; i++) strTemp += _T("0");
	}
	for(i = 0; i < CANData.DataSize; i++)
	{
		strncpy(szTemp, (LPSTR)(LPCTSTR)strTemp + (i * 2), 2);
		CANData.Data[i] = (BYTE)strtoul(szTemp, NULL, 16);
	}													  

	if(m_CAN.WriteData(&CANData))
	{
		AddString(_T("[  ]"));
	}
	else
	{
		AddString(_T("[   ]"));
	}
}

//  
void CTestDlg::OnButtonPeriodSend() 
{
	if(m_ctrlPeriodSend.GetCheck()) SetTimer(0, 200, NULL);		// 100 ms Timer
	else KillTimer(0);
}

void CTestDlg::OnTimer(UINT nIDEvent) 
{
	switch(nIDEvent)
	{
	case 0:
		OnButtonSend();
		break;
	default:
		break;
	}

	CDialog::OnTimer(nIDEvent);
}

// ͸ ް Ǹ  ͸ ü(STRUCT_CAN_DATA) °  
// SendMessage ȣ
void CTestDlg::OnReceive(WPARAM wParam, LPARAM lParam)
{
	CString str, strTemp;
	int i;

	if((int)lParam == RECEIVE_OK)		//  
	{
		// ޽ 
		if(m_CANData.MessageMode == CAN20A) str = _T("CAN2.0A, ");
		else if(m_CANData.MessageMode == CAN20B) str = _T("CAN2.0B, ");

		// ޽ Ÿ
		if(m_CANData.MessageType == CAN_DATA_FRAME) str += _T("DATA FRAME, ");
		else if(m_CANData.MessageType == CAN_REMOTE_FRAME) str += _T("REMOTE FRAME, ");

		//  
		strTemp.Format(_T("%dBYTE, "), m_CANData.DataSize);
		str += strTemp;

		// ID
		if(m_CANData.MessageMode == CAN20A) strTemp.Format(_T("ID:%03X, "), m_CANData.ID);
		else if(m_CANData.MessageMode == CAN20B) strTemp.Format(_T("ID:%08X, "), m_CANData.ID);
		str += strTemp;

		// 
		for(i = 0; i < m_CANData.DataSize; i++)
		{
			strTemp.Format(_T("%02X "), m_CANData.Data[i]);
			str += strTemp;
		}

		AddString(str);		
	}
	else if((int)lParam == CAN_ERROR)		// CAN  ޽
	{
		switch((int)wParam)
		{
		case TX_WARNING:		// CAN ۽  īͰ 96 ʰ ߻ϴ 
			AddString(_T("[ ERROR : TX WARNING ]"));
			break;
		case RX_WARNING:		// CAN   īͰ 96 ʰ ߻ϴ 
			AddString(_T("[ ERROR : RX WARNING ]"));
			break;
		case TX_ERROR_PASSIVE:	// CAN ۽  īͰ 128 ʰ ߻ϴ 
			AddString(_T("[ ERROR : TX_ERROR_PASSIVE ]"));
			break;
		case RX_ERROR_PASSIVE:	// CAN   īͰ 128 ʰ ߻ϴ 
			AddString(_T("[ ERROR : RX_ERROR_PASSIVE ]"));
			break;
		case BUSOFF_ERROR:		// CAN ,  īͰ 255 ʰ ߻ϴ (BUS-OFF)
			AddString(_T("[ ERROR : BUSOFF_ERROR ]"));
			break;
		default:
			break;
		}
	}
	else if((int)lParam == USB_ERROR)	// USB ȵɶ
	{
		AddString(_T("[  ϴ. ]"));
		m_ctrlPeriodSend.SetCheck(FALSE);
		OnButtonPeriodSend();			 
		m_CAN.ClosePort();

		EnableCtrl(FALSE);
		m_ctrlVersion.SetWindowText(_T(""));	
	}
}

// ͸ ް Ǹ  ͸ ü(STRUCT_CAN_DATA) °  
// Callback
void CTestDlg::MyCallback( BYTE nReceiveType, BYTE nError )
{
	CString str, strTemp;
	int i;

	if(nReceiveType == RECEIVE_OK)		//  
	{
		// ޽ 
		if(g_pTestDlg->m_CANData.MessageMode == CAN20A) str = _T("CAN2.0A, ");
		else if(g_pTestDlg->m_CANData.MessageMode == CAN20B) str = _T("CAN2.0B, ");

		// ޽ Ÿ
		if(g_pTestDlg->m_CANData.MessageType == CAN_DATA_FRAME) str += _T("DATA FRAME, ");
		else if(g_pTestDlg->m_CANData.MessageType == CAN_REMOTE_FRAME) str += _T("REMOTE FRAME, ");

		//  
		strTemp.Format(_T("%dBYTE, "), g_pTestDlg->m_CANData.DataSize);
		str += strTemp;

		// ID
		if(g_pTestDlg->m_CANData.MessageMode == CAN20A) strTemp.Format(_T("ID:%03X, "), g_pTestDlg->m_CANData.ID);
		else if(g_pTestDlg->m_CANData.MessageMode == CAN20B) strTemp.Format(_T("ID:%08X, "), g_pTestDlg->m_CANData.ID);
		str += strTemp;

		// 
		for(i = 0; i < g_pTestDlg->m_CANData.DataSize; i++)
		{
			strTemp.Format(_T("%02X "), g_pTestDlg->m_CANData.Data[i]);
			str += strTemp;
		}

		g_pTestDlg->AddString(str);		
	}
	else if(nReceiveType == CAN_ERROR)		// CAN  ޽
	{
		switch(nError)
		{
		case TX_WARNING:		// CAN ۽  īͰ 96 ʰ ߻ϴ 
			g_pTestDlg->AddString(_T("[ ERROR : TX WARNING ]"));
			break;
		case RX_WARNING:		// CAN   īͰ 96 ʰ ߻ϴ 
			g_pTestDlg->AddString(_T("[ ERROR : RX WARNING ]"));
			break;
		case TX_ERROR_PASSIVE:	// CAN ۽  īͰ 128 ʰ ߻ϴ 
			g_pTestDlg->AddString(_T("[ ERROR : TX_ERROR_PASSIVE ]"));
			break;
		case RX_ERROR_PASSIVE:	// CAN   īͰ 128 ʰ ߻ϴ 
			g_pTestDlg->AddString(_T("[ ERROR : RX_ERROR_PASSIVE ]"));
			break;
		case BUSOFF_ERROR:		// CAN ,  īͰ 255 ʰ ߻ϴ (BUS-OFF)
			g_pTestDlg->AddString(_T("[ ERROR : BUSOFF_ERROR ]"));
			break;
		default:
			break;
		}
	}
	else if(nReceiveType == USB_ERROR)	// USB ȵɶ
	{
		g_pTestDlg->AddString(_T("[  ϴ. ]"));
		g_pTestDlg->m_ctrlPeriodSend.SetCheck(FALSE);
		g_pTestDlg->OnButtonPeriodSend();
		g_pTestDlg->m_CAN.ClosePort();

		g_pTestDlg->EnableCtrl(FALSE);
		g_pTestDlg->m_ctrlVersion.SetWindowText(_T(""));	
	}
}

//  
void CTestDlg::OnButtonRecvStart() 
{
	BOOL status;

	if(!m_CAN.RecvEnv(START_RECV_ENV, &status)) return;		//  

	m_ctrlRecvStart.EnableWindow(FALSE);
	m_ctrlRecvStop.EnableWindow(TRUE);
}

//  
void CTestDlg::OnButtonRecvStop() 
{
	BOOL status;

	if(!m_CAN.RecvEnv(STOP_RECV_ENV, &status)) return;		//  

	m_ctrlRecvStart.EnableWindow(TRUE);
	m_ctrlRecvStop.EnableWindow(FALSE);
}

/*
//  Ź޴ ƴ üũϴ Լ
int CTestDlg::IsRecv()
{
	BOOL status;

	if(!m_CAN.RecvEnv(READ_RECV_ENV, &status)) return 0;	//  

	if(status) return START_RECV_ENV;			// 
	else return STOP_RECV_ENV;					//  ƴ
}
*/





